This repository contains the sources necessary to build the blog at:
<https://blog.epheme.re>

# Dependencies

To use this repository as intended, you need, to build the blog, the following
software:

- `git`
- `make`
- `uv`
- `gettext`

To synchronise the blog remotely with its intended target, the synchronisation
is done using `rsync` over `ssh`.

# Install

To install a local copy to work on this blog, you also need other components,
such as the [theme](https://git.epheme.re/fmouhart/pelican-clean-blog) and
[some](https://git.epheme.re/fmouhart/pelican-autopages)
[plugins](https://git.epheme.re/fmouhart/pelican-clean-blog). Those are embedded
in the repository as a git submodule. You can thus simply run git clone with the
`--recurse-submodule` option:

```sh
git clone --recurse-submodule https://git.epheme.re/fmouhart/blog.git fmouhart-blog
```

This blog relies on [pelican](https://getpelican.com) as a static site
generator. To manage the different python dependencies of this project, we are
using [`uv`](https://github.com/astral-sh/uv) as a python project manager.

Moreover, translations are managed with python `gettext` which requires
compiling the translation file.

Those two steps are performed with the following command:

```sh
make init
```

# Development

When writing an article, you can run the blog with `livereload` enabled with the
command:

```sh
make dev
```

It’ll span a local development server on port `8000`: <http://localhost:8000>
